# Contributing to PWA Builder

## Join in the Fun

PWA Builder is a community project. Our goal is to leverage community tools when possible, build for the platforms the Web Developer community will target, and solicit contributes from the community at large.  We would love to have some help from our developers. You can contribute in a number of ways:

1. **Report a Bug**:  We know we have them, you know we have them. Go to GitHub and help us [identify them](https://github.com/manifoldjs/ManifoldJS/issues).
2. **Fix a Bug or add a feature**:  We happily accept code contributions that make our framework better. We have a few code contribution requirements that need to be met (see contribution guidelines below).
3. **Support a new platform**: Are there other platforms that your targeting that support (or have a polyfill for) hosted web apps?  Contribute the code to support additional platforms (see contribute guidelines below).


## Contribution Guidelines

1. Code contribution must have an issue tracking it in the issue tracker that has been approved (Status = Active) by the PWA Builder team. Your pull request should include a link to the bug that you are fixing
2. You will need to complete a Contributor License Agreement (CLA). Briefly, this agreement testifies that you are granting us permission to use the submitted change according to the terms of the project’s license, and that the work being submitted is under appropriate copyright. (docx:  [Microsoft Contribution License Agreement.docx](https://www.codeplex.com/Download?ProjectName=typescript&DownloadId=822190), pdf:  [Microsoft Contribution License Agreement.pdf](https://www.codeplex.com/Download?ProjectName=typescript&DownloadId=921298) ).
3. Contribution should be done through a pull request:

	1. Requests need not be a single commit, but should be a linear sequence of commits (i.e. no merge commits in your PR)
	2. Have clear commit messages ("bug fix" and "new feature" are reserved for the core team :P )

4. Should include a simple test case for you change (that passes :) ). Test cases should utilize existing test frameworks (mocha.js, should.js)
